#include<iostream>
#include<vector>
#include<array>
#include<string>
#include <queue>

using namespace std;

bool dfs1(vector<string>& map, int x, int y, int dir, vector<string>& ans, vector<vector<vector<int> > > &visited)
{
    queue<int> q;
    queue<string> p;
    p.push("");
    q.push(x); q.push(y); q.push(dir);
    visited[x][y][dir]=1;
    while(!q.empty()) {
     //  cout << p.size() << endl;
       int a, b, d;
       a=q.front(); q.pop();
       b=q.front(); q.pop();
       d=q.front(); q.pop();
       string s=p.front(); p.pop();
       for(int i = 1; i<4; i++) {
           if(!visited[a][b][(d+i)%4]) {
               visited[a][b][(d+i)%4]=1;
               q.push(a); q.push(b); q.push((d+i)%4);
               if(i==1) p.push(s+"R");
               if(i==2) p.push(s+"U");
               if(i==3) p.push(s+"L");
           }
       }

       if(d==0) {
               a--;
           }
           else if (d==1) {
               b++;
           }
           else if(d==2) {
               a++;
           }
           else if(d==3) {
               b--;
           }

           if(a>=0 && a<map.size() && b>=0 && b<map[0].size() && map[a][b]!='#' && !visited[a][b][d]) {


               q.push(a); q.push(b); q.push(d);
               p.push(s+"F");
               if(map[a][b]=='E') ans.push_back(s+"F");
           }

    }
}


bool dfs2(vector<string>& map, int x, int y, int dir, vector<string>& ans, vector<vector<vector<int> > > &visited)
{
    queue<int> q;
    queue<string> p;
    p.push("");
    q.push(x); q.push(y); q.push(dir);
    visited[x][y][dir]=1;
    while(!q.empty()) {
     //  cout << p.size() << endl;
       int a, b, d;
       a=q.front(); q.pop();
       b=q.front(); q.pop();
       d=q.front(); q.pop();
       string s=p.front(); p.pop();
       for(int i = 1; i<4; i++) {
           if(!visited[a][b][(d+i)%4]) {
               visited[a][b][(d+i)%4]=1;
               q.push(a); q.push(b); q.push((d+i)%4);
               if(i==1) p.push(s+"R");
               if(i==2) p.push(s+"U");
               if(i==3) p.push(s+"L");
           }
       }
       while(a>=0 && a<map.size() && b>=0 && b<map[0].size() && map[a][b]!='#')
       if(d==0) {
               a--;
           }
           else if (d==1) {
               b++;
           }
           else if(d==2) {
               a++;
           }
           else if(d==3) {
               b--;
           }
       }
           if(a>=0 && a<map.size() && b>=0 && b<map[0].size() && map[a][b]!='#' && !visited[a][b][d]) {


               q.push(a); q.push(b); q.push(d);
               p.push(s+"(AF!)");
               if(map[a][b]=='E') ans.push_back(s+"(AF!)");
           }

    }
}

int main() {
	int r, s;
	while(cin>>r >> s) {
                vector<vector<vector<int> > > visited(r,vector<vector<int>> (s,vector<int>(4,0)));
                for (int i=0; i<r; i++)
                    for (int x=0; x<s; x++)
                    for(int j = 0; j<4; j++)
                    visited[i][x][j] = 0;

                vector<string> v;
                cin.get();
                for(int i= 0; i<r; i++) {
                       string cc;
                        getline(cin, cc);
                        v.push_back(string(cc));
                }
                vector<string> res;
		int rs, ss, dir; 
		for(int i = 0; i<r; i++)
			for(int j = 0; j<s; j++) {
				if(v[i][j]=='v' ||v[i][j]=='>' ||v[i][j]=='<' ||v[i][j]=='^' ) {
					rs=i; ss=j;
					if(v[i][j]=='v') dir=2;
					else if(v[i][j]=='^') dir=0;
					else if(v[i][j]=='>') dir=1;
					else if(v[i][j]=='<') dir=3;
				}
			}
		
                dfs1(v,rs, ss, dir, res, visited);
                dfs1(v,rs, ss, dir, res, visited);
                cout << res[0] << endl;
	}
}
