#include <iostream>
#include <vector>

using namespace std;

int main()
{
    int n, k;
    while (cin>>n>>k)
    {
        vector<vector<int>> table(n);
        vector<long long> prefix(n+1, 0);
        vector<int> num(k+1, 0);
        vector<int> start(n, -1);

        for (int i=0; i<n; ++i)
        {
            int tmp;
            cin>>tmp;
            table[i].resize(tmp);
            for (int j=0; j<tmp; ++j)
                cin>>table[i][j];
        }

        // check if possible
        {
            vector<bool> seen(k+1, 0);
            for (int i=0; i<n; ++i)
                for (int j=0; j<table[i].size(); ++j)
                    seen[table[i][j]] = true;
            bool ok = true;
            for (int i=1; i<=k; ++i)
                if (!seen[i])
                    ok = false;
            if (!ok)
            {
                cout<<-1<<endl;
                continue;
            }
        }

        // mow possible
        for (int i=1; i<=n; ++i)
            prefix[i] = table[i].size() + prefix[i-1];

        int last = 0;
        long long missing = k;
        for (int iter=0; iter<2; ++iter)
        {
            for (int i=0; i<n; ++i)
            {
                for (int j=0; j<table[i].size(); ++j)
                {
                    if (num[table[i][j]] == 0)
                        missing--;
                    num[table[i][j]]++;
                }
            cout<<"missings"<<endl;
            for (int j=0; j<=k; ++j)
                cout<<num[j]<<" ";
            cout<<"missing: "<<missing<<" i="<<i<<endl;
            cout<<endl;
                while (missing == 0)
                {
                    cout<<" in while"<<endl;
                    start[i] = last;
                    cout<<"start: "<<start[i]<<endl;
                    // remove last
                    for (int j=0; j<table[i].size(); ++j)
                    {
                        if (num[table[i][j]] == 1)
                            missing++;
                        num[table[i][j]]--;
                    }
                    last = (last+1)%n;
                }
            }
        }

        cout<<"starts"<<endl;
        for (int i=0; i<n; ++i)
            cout<<start[i]<<" ";
        cout<<endl;


    }
}
